Index: trunk/src/VBox/Runtime/Makefile.kmk
===================================================================
--- trunk/src/VBox/Runtime/Makefile.kmk	(revision 55307)
+++ trunk/src/VBox/Runtime/Makefile.kmk	(revision 55308)
@@ -657,4 +657,6 @@
 	common/asm/ASMGetXcr0.asm \
 	common/asm/ASMSetXcr0.asm \
+	common/asm/ASMXSave.asm \
+	common/asm/ASMXRstor.asm \
 	common/math/bignum-amd64-x86.asm
 RuntimeR3_SOURCES.amd64 += \
@@ -670,4 +672,6 @@
 	common/asm/ASMGetXcr0.asm \
 	common/asm/ASMSetXcr0.asm \
+	common/asm/ASMXSave.asm \
+	common/asm/ASMXRstor.asm \
 	common/math/bignum-amd64-x86.asm \
 	common/math/RTUInt128MulByU64.asm
@@ -1700,4 +1704,6 @@
 	common/asm/ASMGetXcr0.asm \
 	common/asm/ASMSetXcr0.asm \
+	common/asm/ASMXSave.asm \
+	common/asm/ASMXRstor.asm \
 	common/asm/ASMRdMsrEx.asm \
 	common/asm/ASMWrMsrEx.asm
@@ -1712,4 +1718,6 @@
 	common/asm/ASMGetXcr0.asm \
 	common/asm/ASMSetXcr0.asm \
+	common/asm/ASMXSave.asm \
+	common/asm/ASMXRstor.asm \
 	common/asm/ASMRdMsrEx.asm \
 	common/asm/ASMWrMsrEx.asm
Index: trunk/src/VBox/Runtime/common/asm/ASMGetXcr0.asm
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMGetXcr0.asm	(revision 55307)
+++ trunk/src/VBox/Runtime/common/asm/ASMGetXcr0.asm	(revision 55308)
@@ -28,4 +28,5 @@
 ;* Header Files                                                                *
 ;*******************************************************************************
+%define RT_ASM_WITH_SEH64
 %include "iprt/asmdefs.mac"
 
@@ -37,4 +38,5 @@
 ;
 BEGINPROC_EXPORTED ASMGetXcr0
+SEH64_END_PROLOGUE
         xor     ecx, ecx                ; XCR0
         xgetbv
Index: trunk/src/VBox/Runtime/common/asm/ASMSetXcr0.asm
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMSetXcr0.asm	(revision 55307)
+++ trunk/src/VBox/Runtime/common/asm/ASMSetXcr0.asm	(revision 55308)
@@ -28,4 +28,5 @@
 ;* Header Files                                                                *
 ;*******************************************************************************
+%define RT_ASM_WITH_SEH64
 %include "iprt/asmdefs.mac"
 
@@ -38,4 +39,5 @@
 ;
 BEGINPROC_EXPORTED ASMSetXcr0
+SEH64_END_PROLOGUE
 %ifdef ASM_CALL64_MSC
         mov     rdx, rcx
Index: trunk/src/VBox/Runtime/common/asm/ASMXRstor.asm
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMXRstor.asm	(revision 55308)
+++ trunk/src/VBox/Runtime/common/asm/ASMXRstor.asm	(revision 55308)
@@ -0,0 +1,64 @@
+; $Id$
+;; @file
+; IPRT - ASMRstor().
+;
+
+;
+; Copyright (C) 2006-2015 Oracle Corporation
+;
+; This file is part of VirtualBox Open Source Edition (OSE), as
+; available from http://www.virtualbox.org. This file is free software;
+; you can redistribute it and/or modify it under the terms of the GNU
+; General Public License (GPL) as published by the Free Software
+; Foundation, in version 2 as it comes in the "COPYING" file of the
+; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+;
+; The contents of this file may alternatively be used under the terms
+; of the Common Development and Distribution License Version 1.0
+; (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+; VirtualBox OSE distribution, in which case the provisions of the
+; CDDL are applicable instead of those of the GPL.
+;
+; You may elect to license modified versions of this file under the
+; terms and conditions of either the GPL or the CDDL or both.
+;
+
+;*******************************************************************************
+;* Header Files                                                                *
+;*******************************************************************************
+%define RT_ASM_WITH_SEH64
+%include "iprt/asmdefs.mac"
+
+BEGINCODE
+
+;;
+; Loads extended CPU state.
+; @param    pXStateArea Pointer to the XRSTOR state area.
+;                       msc=rcx, gcc=rdi, x86=[esp+4]
+; @param    fMask       The 64-bit state component mask.
+;                       msc=rdx, gcc=rsi, x86=[esp+8]
+;
+BEGINPROC_EXPORTED ASMRstor
+SEH64_END_PROLOGUE
+%ifdef ASM_CALL64_MSC
+        mov     rdx, rdx
+        shr     rdx, 32
+        mov     eax, edx
+        xrstor  [rcx]
+%elifdef ASM_CALL64_GCC
+        mov     rdx, rsi
+        shr     rdx, 32
+        mov     eax, esi
+        xrstor  [rdi]
+%elifdef RT_ARCH_X86
+        mov     ecx, [esp + 4]
+        mov     eax, [esp + 8]
+        mov     edx, [esp + 12]
+        xrstor  [ecx]
+%else
+ %error "Undefined arch?"
+%endif
+        ret
+ENDPROC ASMRstor
+
Index: trunk/src/VBox/Runtime/common/asm/ASMXSave.asm
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMXSave.asm	(revision 55308)
+++ trunk/src/VBox/Runtime/common/asm/ASMXSave.asm	(revision 55308)
@@ -0,0 +1,64 @@
+; $Id$
+;; @file
+; IPRT - ASMXSave().
+;
+
+;
+; Copyright (C) 2006-2015 Oracle Corporation
+;
+; This file is part of VirtualBox Open Source Edition (OSE), as
+; available from http://www.virtualbox.org. This file is free software;
+; you can redistribute it and/or modify it under the terms of the GNU
+; General Public License (GPL) as published by the Free Software
+; Foundation, in version 2 as it comes in the "COPYING" file of the
+; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+;
+; The contents of this file may alternatively be used under the terms
+; of the Common Development and Distribution License Version 1.0
+; (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+; VirtualBox OSE distribution, in which case the provisions of the
+; CDDL are applicable instead of those of the GPL.
+;
+; You may elect to license modified versions of this file under the
+; terms and conditions of either the GPL or the CDDL or both.
+;
+
+;*******************************************************************************
+;* Header Files                                                                *
+;*******************************************************************************
+%define RT_ASM_WITH_SEH64
+%include "iprt/asmdefs.mac"
+
+BEGINCODE
+
+;;
+; Saves extended CPU state.
+; @param    pXStateArea Pointer to the XSAVE state area.
+;                       msc=rcx, gcc=rdi, x86=[esp+4]
+; @param    fComponents The 64-bit state component mask.
+;                       msc=rdx, gcc=rsi, x86=[esp+8]
+;
+BEGINPROC_EXPORTED ASMXSave
+SEH64_END_PROLOGUE
+%ifdef ASM_CALL64_MSC
+        mov     rdx, rdx
+        shr     rdx, 32
+        mov     eax, edx
+        xsave   [rcx]
+%elifdef ASM_CALL64_GCC
+        mov     rdx, rsi
+        shr     rdx, 32
+        mov     eax, esi
+        xsave   [rdi]
+%elifdef RT_ARCH_X86
+        mov     ecx, [esp + 4]
+        mov     eax, [esp + 8]
+        mov     edx, [esp + 12]
+        xsave   [ecx]
+%else
+ %error "Undefined arch?"
+%endif
+        ret
+ENDPROC ASMXSave
+